/*
Future:
I would like to fix the status bar so that if it never loads
it will actually alert you so.
*/

const savefile=returnProfDir("boc13579.tmp");

function onload() {
  //Set Global Variables
  txtAmount = document.getElementById('txtAmount');
  txtDate = document.getElementById('txtDate');
  txtTime = document.getElementById('txtTime');
  txtBuy = document.getElementById('txtBuy');
  txtAsk = document.getElementById('txtAsk');
  txtFrom = document.getElementById('txtFrom');
  txtTo = document.getElementById('txtTo');  
  txtRate = document.getElementById('txtRate');
  txtConvert = document.getElementById('txtConvert');
  mnuFrom = document.getElementById('mnuFrom');
  mnuTo = document.getElementById('mnuTo');
  btnSbmt = document.getElementById('submit');
  btnReset = document.getElementById('reset');
  status = document.getElementById("status");
  stringBundle = document.getElementById('exchsidebar-bundle');
  resetForm();
}

function chkPrefs() {
  //Check for preferences, and if not, set defaults
  if (!exchsidebarPrefs.getPrefValue(exchsidebarPrefs.AMOUNT, "str", null)) {
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.FROM, "str", "USD");
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.TO, "str", "CAD");
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.AMOUNT, "str", "1.00");
  }
  exchConvertFrom = exchsidebarPrefs.getPrefValue(exchsidebarPrefs.FROM, "str",
    null);
  exchConvertTo = exchsidebarPrefs.getPrefValue(exchsidebarPrefs.TO, "str",
    null);
  exchConvertAmount = exchsidebarPrefs.getPrefValue(exchsidebarPrefs.AMOUNT,
    "str", null);
}

function resetForm() {
  chkPrefs();
  
  //Rest all of the forms to defaults
  txtAmount.value = exchConvertAmount;
  txtDate.value = "";
  txtTime.value = "";
  txtBuy.value = "";
  txtAsk.value = "";
  txtFrom.value = "";
  txtTo.value = "";
  txtRate.value = "";
  txtConvert.value = "";
  mnuFrom.value = exchConvertFrom;
  mnuTo.value = exchConvertTo;
  resetBtnReset("true");
}

function graph() {
  window.open('chrome://exchsidebar/content/graph/graph.xul', 'options',
    'chrome,centerscreen');
}

function preferences() {
  btnReset.setAttribute('disabled', 'false'); 
  /*--------------------------------------------------------
  Load up the options dialog, and once it has closed, have
  this script change the options that were set.
  --------------------------------------------------------*/
  window.open('chrome://exchsidebar/content/preferences/preferences.xul',
    'options', 'chrome,centerscreen');
}

function parseCSVfile() {
  var parselocalcsv = savefile;
  var fileIn = FileIO.open(parselocalcsv);
  var str = FileIO.read(fileIn);
  var strsplit = str.split(',');
  FileIO.unlink(fileIn);
  return strsplit;
}

function delfile(deletefile) {
  var fileOut = FileIO.open(deletefile);
  FileIO.unlink(fileOut);
}

function resetBtnReset(state) {
  btnReset.setAttribute("disabled", state);
}

function sbmtCurrency() {
  flagConnection = 0;
  if(isNaN(txtAmount.value) == true) {
    alert (stringBundle.getString("sbmtCurrency.error"));
    return;    
  }
  resetBtnReset("false");
  setStatus(stringBundle.getString("loading.label") + 
    ' http://finance.yahoo.com/d/quotes.csv?s=' + mnuFrom.value + mnuTo.value +
    '=X&f=sl1d1t1ba&e=.csv');
  downloadFile('http://finance.yahoo.com/d/quotes.csv?s=' + mnuFrom.value + 
    mnuTo.value + '=X&f=sl1d1t1ba&e=.csv', savefile);
}

function invertCurr() {
  flagConnection = 0;
  if(isNaN(txtAmount.value) == true) {
    alert (stringBundle.getString("sbmtCurrency.error"));
    return;    
  }
  resetBtnReset("false");
  var mnuTmp = mnuTo.value;
  mnuTo.value = mnuFrom.value;
  mnuFrom.value = mnuTmp;
  setStatus(stringBundle.getString("loading.label") + 
    ' http://finance.yahoo.com/d/quotes.csv?s=' + mnuFrom.value + mnuTo.value +
    '=X&f=sl1d1t1ba&e=.csv');
  downloadFile('http://finance.yahoo.com/d/quotes.csv?s=' + mnuFrom.value +
    mnuTo.value + '=X&f=sl1d1t1ba&e=.csv', savefile);
}

/*------------------------------------------------------------------------------
Returns the savefile var with the profile directory 
of the user/application appended to the beginning of 
the variable
------------------------------------------------------------------------------*/ 
function returnProfDir(filename) {
  //start, used from http://www.captain.at/programming/xul/
  try {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  } catch (e) {
    alert("Permission to save file was denied.");
  }
  
  // get the path to the user's home (profile) directory
  const DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1","nsIProperties");
  
  try { 
    path=(new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
  } catch (e) {
    alert("error");
  }
  
  // determine the file-separator
  if (path.search(/\\/) != -1) {
    path = path + "\\";
  } else {
    path = path + "/";
  }
  
  newfilename = path+filename;
  //end, used from http://www.captain.at/programming/xul/
  return newfilename;
}

//modified downloadFile function from http://xul.andreashalter.ch/
function downloadFile(srcURI, savefile) { 
  //new obj_URI object 
  try { 
    var obj_URI = Components.classes["@mozilla.org/network/io-service;1"].
      getService(Components.interfaces.nsIIOService).newURI(srcURI, null, null); 
  } catch (e) { alert(e); } 
  
  //new file object 
  try { 
    var obj_TargetFile = Components.classes["@mozilla.org/file/local;1"].
      createInstance(Components.interfaces.nsILocalFile); 
  } catch (e) { alert(e); } 
  
  //set file with path 
  obj_TargetFile.initWithPath(savefile); 
  
  //if file doesn't exist, create 
  if(!obj_TargetFile.exists()) { 
    try { 
      obj_TargetFile.create(0x00,0644); 
    } catch (e) { alert(e); } 
  } 

  persistListener = new PersistProgressListener;
  
  //new persitence object 
  try { 
    obj_Persist = Components.
      classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
      createInstance(Components.interfaces.nsIWebBrowserPersist); 
  } catch (e) { alert(e); }  
  
  //obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile);
  
  //obj_Persist.currentState,obj_Persist.PERSIST_STATE_FINISHED
  try { 
    obj_Persist.progressListener = persistListener;
  }
  catch (e) { alert(e); }  
  
  obj_Persist.saveURI(obj_URI,null,null,null,null,obj_TargetFile);
}

function setProgress(current, max) {
  progress = current + " out of " + max;
}

function PersistProgressListener() {
  this.init();
}

PersistProgressListener.prototype = {
  _requestsStarted: 0,
  _requestsFinished: 0,
  QueryInterface : function(aIID) {
    if(aIID.equals(Components.interfaces.nsIWebProgressListener))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },
  
  init : function() {
  
  },
  
  destroy : function() {
  
  },
  
  // nsIWebProgressListener
  onProgressChange : function (aWebProgress, aRequest,
                               aCurSelfProgress, aMaxSelfProgress,
                               aCurTotalProgress, aMaxTotalProgress) {
    setProgress(aCurTotalProgress, aMaxTotalProgress);
  },
  
  onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus) {
    const WPL = Components.interfaces.nsIWebProgressListener;
    
    var progress = document.getElementById('progress');
    
    if (aStateFlags & WPL.STATE_IS_REQUEST) {
      if (aStateFlags & WPL.STATE_START) {
        this._requestsStarted++;
      } else if (aStateFlags & WPL.STATE_STOP) {
        this._requestsFinished++;
      }
      if (this._requestsStarted > 0) {
        var value = (100 * this._requestsFinished) / this._requestsStarted;
        progress.setAttribute("mode", "determined");
        progress.setAttribute("value", value + "%");
      }
    }
    
    if (aStateFlags & WPL.STATE_IS_NETWORK) {
      if (aStateFlags & WPL.STATE_START) {
        progress.setAttribute("style", "");
      } else if (aStateFlags & WPL.STATE_STOP) { 
        setTimeout("resetProgressBar()", 200);
        this.onStatusChange(aWebProgress, aRequest, 0, stringBundle.
          getString("done.label"));
        this._requestsStarted = this._requestsFinished = 0;
      }
    }
    
    
    /*Need some work somewhere in here to alert the user 
    if the file doesn't download*/
    
    if (aStateFlags==327696) {
      csvarray = parseCSVfile();
      //alert(csvarray);
      //csvarray[0]"USDCAD=X"
      //csvarray[1]1.2354
      //csvarray[2]"4/22/2005"
      //csvarray[3]"5:34pm"
      //csvarray[4]1.2354
      //csvarray[5]1.2357 
      
      //grab the input values off of the form and compute the values
      //for the output form
      
      txtDate.value = stripQuotes(csvarray[2]);
      txtTime.value = stripQuotes(csvarray[3]);
      txtBuy.value = csvarray[4];
      txtAsk.value = csvarray[5];
      txtFrom.value = txtAmount.value + ' ' + mnuFrom.label;
      txtTo.value = mnuTo.label;            
      txtRate.value = csvarray[1];
      txtConvert.value = Math.round((txtAmount.value * csvarray[1])*100)/100 +
        ' ' + mnuTo.label;
    }
  },
  
  onLocationChange : function(aWebProgress, aRequest, aLocation) {
  },
  
  onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage) {
    setStatus(aMessage);
  },
  
  onSecurityChange : function(aWebProgress, aRequest, aState) {
  }
}

function setStatus(text) {
  status.setAttribute("label", text);
}

function stripQuotes(txtQuoted) {
  try {
    var txtQuotesRemoved = txtQuoted.substring(1,txtQuoted.length - 1);
  }
  catch (e) {
    //submit and invert buttons set it to 0 and this
    //keeps it from alerting twice when having
    //communication issues with Yahoo.
    if (flagConnection==0) {
      //alert(e);
      alert(stringBundle.getString("connection.error"));
    }
  }
  flagConnection = flagConnection + 1;
  return txtQuotesRemoved;
}

function resetProgressBar() {
  var progress = document.getElementById('progress');
  progress.setAttribute('value', 0);
}