/*------------------------------------------------------------------------------
Future: I would like to implement a status bar on this graph like the main
sidebar.

Question: I wonder if using the global variable "graphSpan" is considered bad
rather than passing it around between functions as a local variable. ??? It 
seems a little harder to follow as a global... but lots easier to play with
as a smaller program... but what about when it get's larger.
------------------------------------------------------------------------------*/

function graphInit() {
  stringBundle = document.getElementById('graph-bundle');
  graphSpan = '1y?';
  graphSpanWord = stringBundle.getString("time.oneYear");
  currFrom = window.opener.document.getElementById('mnuFrom').value;
  currTo = window.opener.document.getElementById('mnuTo').value;
  exchInfo = document.getElementById('exchInfo');
  x = 'x';
  exchInfo.value = currFrom + '/' + currTo + ' - ' + graphSpanWord;
  document.getElementById('iGraph').setAttribute('src', 
    'http://ichart.finance.yahoo.com/' + graphSpan + currFrom.toLowerCase() + 
    currTo.toLowerCase() + '=' + x);
  document.getElementById('oneYear').focus();
}

function graphChange(time) {
  //set global variable to the one passed from graph.xul
  graphSpan = time;
  currCodeChk();
  exchInfo.value = currFrom.toUpperCase() + '/' + currTo.toUpperCase() + ' - ' +
    graphSpanWord;
  document.getElementById('iGraph').setAttribute('src',
    'http://ichart.finance.yahoo.com/' + graphSpan + currFrom + currTo + '=' + 
    x);  
}

function graphInvert() {
  currCodeChk();
  exchInfo.value = currTo.toUpperCase() + '/' + currFrom.toUpperCase() + ' - ' +
    graphSpanWord;
  document.getElementById('iGraph').setAttribute('src',
    'http://ichart.finance.yahoo.com/' + graphSpan + currTo + currFrom + '=' + 
    x);
    
  //swapping values of the to and from so that it can be re-inverted. :-)
  currTemp = currFrom;
  currFrom = currTo;
  currTo = currTemp;
}

/*------------------------------------------------------------------------------
Weird stuff, I sent the 1y? url to Yahoo with USDCAD, and on linux it would
return, "Chart Not Available," but on windows it worked fine. On linux I 
changed it to usdcad like yahoo has the picture url, and it worked fine.
 
So here we set the case of the currTo and currFrom to match how Yahoo has 
their urls, instead of using all caps.

1 day and 1 week seem to always be uppercase, but the rest are lowercase, the 
same applies for the "x" appended on the end of the url
------------------------------------------------------------------------------*/

function currCodeChk() {
  if (graphSpan == 'b?s=') {
    currTo = currTo.toUpperCase();
    currFrom = currFrom.toUpperCase();
    graphSpanWord = stringBundle.getString("time.oneDay");
    x = x.toUpperCase();
  }
  else if (graphSpan == 'w?s=') {
    currTo = currTo.toUpperCase();
    currFrom = currFrom.toUpperCase();
    graphSpanWord = stringBundle.getString("time.oneWeek");
    x = x.toUpperCase();
  }
  else if (graphSpan == '3m?') {
    currTo = currTo.toLowerCase();
    currFrom = currFrom.toLowerCase();
    graphSpanWord = stringBundle.getString("time.thrMonth");
    x = x.toLowerCase();
  }
  else if (graphSpan == '1y?') {
    currTo = currTo.toLowerCase();
    currFrom = currFrom.toLowerCase();
    graphSpanWord = stringBundle.getString("time.oneYear");
    x = x.toLowerCase();
  }
  else if (graphSpan == '2y?') {
    currTo = currTo.toLowerCase();
    currFrom = currFrom.toLowerCase();
    graphSpanWord = stringBundle.getString("time.twoYear");
    x = x.toLowerCase();
  }
  else if (graphSpan == '5y?') {
    currTo = currTo.toLowerCase();
    currFrom = currFrom.toLowerCase();
    graphSpanWord = stringBundle.getString("time.fivYear");
    x = x.toLowerCase();
  }
}