function preferencesInit() {
  //init global objects
  txtAmount = document.getElementById('txtAmount');
  mnuFrom = document.getElementById('mnuFrom');
  mnuTo = document.getElementById('mnuTo');
  stringBundle = document.getElementById('prefs-bundle');
  
  //Check for preferences, and if not, set defaults
  if (!exchsidebarPrefs.getPrefValue(exchsidebarPrefs.AMOUNT, "str", null)) {
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.FROM, "str", "USD");
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.TO, "str", "CAD");
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.AMOUNT, "str", "1.00");
  }
  exchConvertFrom = exchsidebarPrefs.getPrefValue(exchsidebarPrefs.FROM, "str",
    null);
  exchConvertTo = exchsidebarPrefs.getPrefValue(exchsidebarPrefs.TO, "str",
    null);
  exchConvertAmount = exchsidebarPrefs.getPrefValue(exchsidebarPrefs.AMOUNT, 
    "str", null);

  setPreferencesForm();
}

/*------------------------------------------------------------------------------
preferences functions, from sage project
------------------------------------------------------------------------------*/ 
var exchsidebarPrefs = {

  FROM: "exch.from",
  TO: "exch.to",
  AMOUNT: "exch.amount",

  setPrefValue : function(aPrefString, aPrefType, aValue) {
    var nsISupportsString = Components.interfaces.nsISupportsString;
    var xpPref = Components.classes["@mozilla.org/preferences;1"].
      getService(Components.interfaces.nsIPrefBranch);
    
    var prefType = xpPref.getPrefType(aPrefString);
    
    try {
      switch(aPrefType) {
        case "wstr":
          var string = Components.classes['@mozilla.org/supports-string;1'].
            createInstance(nsISupportsString);
          string.data = aValue;
          return xpPref.setComplexValue(aPrefString, nsISupportsString, string);
          break;
        case "str":
          return xpPref.setCharPref(aPrefString, aValue);
          break;
        case "int":
          aValue = parseInt(aValue);
          return xpPref.setIntPref(aPrefString, aValue);
          break;
        case "bool":
        default:
          if(typeof(aValue) == "string") {
            aValue = (aValue == "true");
          }
          return xpPref.setBoolPref(aPrefString, aValue);
          break;
        }
    } catch(e) {
    }
    return null;
  },

  getPrefValue : function(aPrefString, aPrefType, aDefault) {
    var nsISupportsString = Components.interfaces.nsISupportsString;
    var xpPref = Components.classes["@mozilla.org/preferences;1"].
      getService(Components.interfaces.nsIPrefBranch);
    
    if(xpPref.getPrefType(aPrefString) == xpPref.PREF_INVALID) {
    	return aDefault;
    }
    try {
      switch (aPrefType) {
        case "wstr":
          return xpPref.getComplexValue(aPrefString, nsISupportsString).data;
          break;
        case "str":
          return xpPref.getCharPref(aPrefString).toString();
          break;
        case "int":
          return xpPref.getIntPref(aPrefString);
          break;
        case "bool":
        default:
          return xpPref.getBoolPref(aPrefString);
          break;
      }
    } catch(e) {
    }
    return aDefault;
  },

  clearPref: function(aPrefString) {
    var xpPref = Components.classes["@mozilla.org/preferences;1"].
      getService(Components.interfaces.nsIPrefBranch);
    
    try {
      xpPref.clearUserPref(aPrefString);
      return true;
    } catch(e) {
      return false;
    }
  },

  // remove all preferences
  removePrefs: function() {
    var xpPref = Components.classes["@mozilla.org/preferences;1"].
      getService(Components.interfaces.nsIPref);
    
    var prefBranch = xpPref.getBranch("exch.");
    
    try {
      prefBranch.deleteBranch("");
      return true;
    } catch(e) {
      return false;
    }
  },

  addPrefListener: function(aPrefString, aFunc) {
    var prefObserver;
    try {
      prefObserver = {
        domain: aPrefString,
        observe: aFunc
      };
      
      var pbi = Components.classes["@mozilla.org/preferences-service;1"].
        getService(Components.interfaces.nsIPrefBranchInternal);
      pbi.addObserver(prefObserver.domain, prefObserver, false);
    } catch(e) {
      alert(e);
      prefObserver = null;
    }
    
    return prefObserver;
  },

  removePrefListener: function(aObserver) {
    var prefObserver;
    try {
      var pbi = Components.classes["@mozilla.org/preferences-service;1"].
        getService(Components.interfaces.nsIPrefBranchInternal);
      pbi.removeObserver(aObserver.domain, aObserver);
    } catch(e) {
      alert(e)
    }
  }
}

function preferencesOnOk() {
  if(isNaN(txtAmount.value) == true) {
    alert(stringBundle.getString("sbmtCurrency.error"));
    txtAmount.focus();
  }
  else {
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.FROM, 'str', mnuFrom.value);
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.TO, 'str', mnuTo.value);
    exchsidebarPrefs.setPrefValue(exchsidebarPrefs.AMOUNT, 'str', 
      txtAmount.value);
    window.close();
  }
  
}

function setPreferencesForm() {
  //Reset the form to defaults
  mnuFrom.value = exchConvertFrom;
  mnuTo.value = exchConvertTo;
  txtAmount.value = exchConvertAmount;
}